/* global BDF,$$ */
/**
 * Objet global définissant l'espace de nom Balayage
 * 
 * @namespace Balayage
 */
var Balayage = {};

Balayage.array = null;


/******************************************************************************
 * Actions sur Balayage.array
 ******************************************************************************/

Balayage.initArray = function (array) {
    for(var i = 0, len = array.length; i < len; i++) {
        Balayage.completeBalayage(array[i]);
    }
    Balayage.array = array;
    return array;
};

Balayage.getBalayage = function (balayageName) {
    if (!Balayage.array) {
        return null;
    }
    for(let i = 0, len = Balayage.array.length; i < len; i++) {
        let balayage = Balayage.array[i];
        if (balayage.name === balayageName) {
            return balayage;
        }
    }
    return null;
};

Balayage.updateBalayage = function (newBalayage) {
    newBalayage = Balayage.completeBalayage(newBalayage);
    BDF.updateInArray(Balayage.array, newBalayage);
    Balayage.List.updateBalayage(newBalayage);
    return newBalayage;
};

Balayage.removeBalayage = function (name) {
    BDF.removeInArray(Balayage.array,name);
    BDF.Pane.removeContents(name);
    BDF.Pane.removeEntry($$("listpane_body"), name);
};

Balayage.insertBalayage = function (balayage) {
    balayage = Balayage.completeBalayage(balayage);
    BDF.insertInArray(Balayage.array, balayage);
    var $entry = BDF.Pane.insertEntry($$("listpane_body"), balayage.name, BDF.render("balayage:list-balayage", balayage));
    BDF.Deploy.ensureLinkVisibility($entry, true);
    $$("listpane_body").animate({
        scrollTop: $entry.offset().top
    }, 1000);
    return balayage;
};

Balayage.completeBalayage = function (balayageObj) {
    var balayageName = balayageObj.name;
    _completeSubdir("_core");
    _completeSubdir("extraction");
    _completeSubdir("xslt");
    return balayageObj;
    
    function _completeSubdir(key) {
        if (balayageObj.hasOwnProperty(key)) {
            var array = balayageObj[key].array;
            for (var j = 0, len = array.length; j < len; j++) {
                array[j].balayageName = balayageName;
            }
        }
    }
    
};


/******************************************************************************
 * Enregistrement de fonction
 ******************************************************************************/

BDF.Pane.registerCheckFunction(function (state) {
    var mainContentKey, balayageName, contentPath;
    $(".pane-list-ActiveItem").removeClass("pane-list-ActiveItem");
    if (state.withMain()) {
        _init();
        let $balayage = BDF.$({role: "entry", name: balayageName});
        BDF.$($balayage, {role: "entry-header"}).addClass("pane-list-ActiveItem");
        let $reference = BDF.$($balayage, {role: "content-reference", contentPath: contentPath});
        BDF.$($reference, {role: "content-title"}).addClass("pane-list-ActiveItem");
        BDF.Pane.ensureVisibility($reference);
    }
    
    
    function _init() {
        mainContentKey = state.mainContentKey;
        let idx = mainContentKey.indexOf("/");
        balayageName = mainContentKey.substring(0, idx);
        contentPath = mainContentKey.substring(idx + 1);
    }
    
});


/******************************************************************************
 * Initialisation
 ******************************************************************************/

BDF.addTemplateOptions({
    helpers: {
    }
});

$(function () {
    BDF.initTemplates();
    BDF.Pane.initLayout();
    $$("layout_list").html(BDF.render("balayage:list-pane", {}));
    BDF.initBeforeUnload();
    BDF.runSerialFunctions(
        BDF.initLangConfiguration,
        Balayage.List.init
    );
});
