/* global BDF,$$ */
/**
 * Objet global définissant l'espace de nom Menu
 * 
 * @namespace Menu
 */
var Menu = {};

Menu.init = function () {
    var corpusSelect = ID("corpusSelect");
    var gotoInput = ID("ficheGotoInput");
    $$("actionSelect").change(_doAction);
    BDF.$({ficheGotoKey: true}).click(function () {
        return _goTo($(this));
    });
    BDF.registerFunction("menu:updateCorpusTree", _updateCorpusTree);
       

    function _doAction() {
        let option = this.options[this.selectedIndex];
        let $option = $(option);
        let target, url;
        if (!__checkValue()) {
            return;
        }
        $$("redoArea").html(BDF.render("menu:actionbutton", {
            url: url,
            text: option.text,
            target: target,
            action: $option.data("action"),
            iconSrc: $option.data("iconSrc")
        }));
        parent[target].document.location = url;
        this.selectedIndex = 0;


        function __checkValue() {
            let value = option.value;
            if (value.length === 0) {
                return false;
            }
            url = value;
            target = $option.data("target");
            if (!parent[target]) {
                alert("Unknown target : " + target);
                return false;
            }
            return true;
        }
    }
    
    function _goTo($link) {
        let key = $link.data("ficheGotoKey");
        let corpus = _getCorpus();
        if (key === "create") {
            $link.attr("href", "edition?corpus=" + corpus + "&page=fiche-creation");
        } else {
            let gotoId = parseInt(gotoInput.value);
            if ((isNaN(gotoId)) || (gotoId < 1)) {
                alert(BDF.Loc.get("_ error.wrong.goto"));
                return false;
            }
            if (key === "read") {
                $link.attr("href", "fiches/" + corpus + "-" + gotoId + ".html");
            }
            else if (key === "write") {
                $link.attr("href", "edition?corpus=" + corpus + "&id=" + gotoId + "&page=fiche-change");
            } else if (key === "indexation") {
                $link.attr("href", "edition?corpus=" + corpus + "&id=" + gotoId + "&page=fiche-indexation");
            } else if (key === "selection") {
                $link.attr("href", "selection?corpus=" + corpus + "&id=" + gotoId + "&page=main:fiches&cmd=SelectionByFiche");
            }
        }
        return true; 
    }
    
    function _updateCorpusTree(corpusTree) {
        let currentCorpus = _getCorpus();
        __complete(corpusTree, "");
        $(corpusSelect).html(BDF.render("menu:corpustree", {
            corpusTree: corpusTree
        }));
        
        
        function __complete(array, indent) {
            for(let node of array) {
                node.indent = indent;
                if (node.node === "group") {
                    __complete(node.array, indent + "\u00A0 \u00A0 ");
                } else if (node.name === currentCorpus) {
                    node.selected = true;
                }
            }
        }
    }
    
    function _getCorpus() {
        if (corpusSelect.selectedIndex < 0) {
            return "";
        }
        return corpusSelect.options[corpusSelect.selectedIndex].value;
    }
};


/******************************************************************************
 * Initialisation
 ******************************************************************************/

$(function () {
    BDF.initTemplates();
    Menu.init();
});