/* global BDF,$$,ScrutariExport,Overlay */

ScrutariExport.Overlay = {};

/******************************************************************************
* Appel des différents formulaires
******************************************************************************/
ScrutariExport.Overlay.showCreationForm = function () {
    if (!BDF.confirmUnload()) {
        return;
    }
    Overlay.start({
        header: BDF.Loc.escape("_ EXP-21"),
        content: BDF.render("scrutariexport:overlay-creationform", {
            commandKey: "EXP-21",
            commandUrl: BDF.getCommandUrl("EXP-21")
        }),
        footer: BDF.render("bdf:overlay-footer", {
            submit: {
                locKey: '_ submit.exportation.scrutariexportcreation'
            }}),
        formAttrs: {
            action: BDF.URL + "exportation",
            method: "POST"
        },
        ajaxForm: {
            dataType: "json",
            success: function (data, textStatus, jqXHR, $form) {
                let done = BDF.Ajax.checkError(data);
                if (done) {
                    BDF.Pane.clearMain();
                    Overlay.end($form, function () {
                        BDF.showCommandMessage(data.commandMessage);
                        ScrutariExport.insertScrutariExport(data.scrutariExport);
                    });
                }
            }
        }
    });
};

ScrutariExport.Overlay.showRemoveConfirm = function (scrutariExportName) {
    if (!BDF.confirmUnload()) {
        return;
    }
    var scrutariExport = ScrutariExport.getScrutariExport(scrutariExportName);
    if (!scrutariExport) {
        return;
    }
    Overlay.start({
        header: BDF.Loc.escape("_ EXP-22"),
        content: BDF.render("scrutariexport:overlay-removeconfirm", {
            name: scrutariExportName,
            title: scrutariExport.title,
            commandKey: "EXP-22",
            commandUrl: BDF.getCommandUrl("EXP-22")
        }),
        footer: BDF.render("bdf:overlay-footer", {
            submit: {
                locKey: '_ submit.exportation.scrutariexportremove'
            }}),
        formAttrs: {
            action: BDF.URL + "exportation",
            method: "POST"
        },
        ajaxForm: {
            dataType: "json",
            success: function (data, textStatus, jqXHR, $form) {
                let done = BDF.Ajax.checkError(data);
                if (done) {
                    Overlay.end($form, function () {
                        BDF.showCommandMessage(data.commandMessage);
                        ScrutariExport.removeScrutariExport(scrutariExportName);
                    });
                }
            }
        }
    });
};

ScrutariExport.Overlay.showRun = function (scrutariExportName) {
    var resultDestinationId = BDF.generateId();
    var scrutariExport = ScrutariExport.getScrutariExport(scrutariExportName);
    if (!scrutariExport) {
        return;
    }
    Overlay.start({
        header: BDF.Loc.escape("_ title.exportation.rundialog"),
        content: BDF.render("scrutariexport:overlay-run", {
            name: scrutariExportName,
            title: scrutariExport.title,
            resultDestinationId: resultDestinationId
        }),
        isWaiting: true,
        afterStart: function ($overlayDialog, waitingCallback) {
            $.ajax ({
                url: BDF.URL + "exportation",
                data: {
                    scrutariexport:  scrutariExportName,
                    cmd: "ScrutariExportRun",
                    json: "scrutariexport-paths"
                },
                dataType: "json",
                success: function (data, textStatus) {
                    BDF.Ajax.success(data, "scrutariExportPaths", function (scrutariExportPaths) {
                        $$(resultDestinationId).html(BDF.render("scrutariexport:overlay-run_result", {
                            rootUrl: BDF.URL,
                            paths:  scrutariExportPaths
                        }));
                    });
                    waitingCallback();
                }
            });
        }
    });
    
};